import time
import datetime
import csv
import json


def De_Anonymization(jsonPaths):
    #读取.csv文件中的数据
    path = "E:/BlockChain_DataSet/complete_edge_v2.csv"
    f = open(path,'r')
    csv_read = csv.reader(f)

    match = {}
    best_match = {}
    line_num = 0
    block_time = 3600
    for line in csv_read:
        line_num += 1
        if (line_num>= 302534 and line_num<=314412):
            print(line)
            tx_time = datetime.datetime.strptime(line[6],"%Y-%m-%d %H:%M:%S")
            tx_time = time.mktime(tx_time.timetuple())
            input_account = line[0]
            output_account = line[2]
            value = int(line[3])*(10^8)

            print(tx_time)
            for jsonPath in jsonPaths:
                with open(jsonPath, 'r', encoding='utf8')as fp:
                    json_data = json.load(fp)
                    if (abs(json_data["time"] - tx_time) < block_time):
                        for tx in json_data["Txs"]:

                            for input in tx["inputs"]:
                                if (int(input["value"]) == value):
                                    if input_account not in match:
                                        match[input_account] = {}
                                    if input["address"] not in match[input_account]:
                                        match[input_account][input["address"]] = 1
                                    else:
                                        match[input_account][input["address"]] += 1

                            for output in tx["putputs"]:
                                if (int(output["value"]) == value):
                                    if output_account not in match:
                                        match[output_account] = {}
                                    if output["address"] not in match[output_account]:
                                        match[output_account][output["address"]] = 1
                                    else:
                                        match[output_account][output["address"]] += 1
        elif (line_num>314412):
            break

    for account in match:
        max_match = 0
        bestmatch_address = None
        for address in account:
            if match[account][address] > max_match:
                max_match = match[account][address]
                bestmatch_address = address
        best_match[account] = bestmatch_address

    return best_match

def match_rate(best_match):
    negitiveNum = 0
    totalNum = 0
    for account in best_match:
        if (best_match[account] == None):
            negitiveNum += 1
        totalNum += 1
    MatchRate = negitiveNum*1.0/totalNum
    return MatchRate

jsonPaths = []      #fill this with paths
best_match = De_Anonymization(jsonPaths)
